

;      Motion blur test animation-driver
;      This control program simulates a "planet" orbiting an
;      invisible sun (a neutron star?)

new

view solid;   use solid rendering for final animation

lton a:lton b; use 2 light sources.
clrbgnd
zoom 200:perspec 350
backgnd no,no:;  turn off any background stuff
cam1 0,0,0:;	 set camera 1 position
clrgrp

frames = 16:;	number of output frames.

input "samples per frame?",samples:; get number of frames-in for 1 frame
sph2 sphere,14:;              make a sphere
scale 50:scale 50:;           shrink it some

select sphere:;               so we can manipulate the object we made.

r1=1200:theta=-180.00:;       set initial motion parameters
r2 = 600:;		      for an elliptical orbit

dtheta1=360/(frames-1):;      outer-loop displacement

dtheta2=dtheta1/(samples*2):; inner-loop displacement angle (shutter-open
;			      equals shutter-closed time).

moveto -1200,0,0:;            planet's initial position
nframes=0:;                   used for first-frame setup

; Note: MBLUR treats the PI1 file created in this ani as the first frame.
; therefore, the first set of frames to be motion-blurred must be one
; less than the rest.  That's why I'm using "nframes" as a first-frame
; indicator.

direct a,7,50,50,50:;            set light-source positions
direct b,4,-50,-50,-50:;	 and brightness
superview

;    begin recording the animation
rstart "C:\anims\blurtest.dlt",m:;   THIS is for my system.  You can
;                                    choose something suited for your
;                                    system.

;  the animation-loops.  The inner loop simulates the time when
;  the camera shutter is open and the outer loop simulates the
;  time the shutter is closed.


for i = theta to 180-dtheta1 step dtheta1:; the outer frame-loop

for j = 0 to samples-1:; inner loop that creates motion-blurred frame
p = dtheta2*j + i:;      calculate inner-loop angle

if nframes = samples then goto skip:; initial output-frame series' creation

x=r1*cos(p):;               calculate new x,y,z position of orbit
z=r2*sin(p)
moveto x,0,z:;              move the planet to its new position

nframes = nframes+1:;       increment first-output-frame detector
superview
record
next j:;                    end of inner motion-blur loop

@skip:
nframes = nframes+1

next i:;                    end of outer camera-shutter loop.

rstop:;    terminate the animation
bell:;      signal we're done
bell
bell


